/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"events.h"
#include"nautaButtons.h"
#include"nautaForms.h"
#include"nautaStr.h"
#include"nautaFormSys.h"
#include"FormSys.h"
#include"serial.h"
#include"timer.h"
#include<PalmOS.h>
static char vexilla;static FormType*f;static int kid;
static void WriteBattery(void)
{UInt8 batpcent;UInt16 b;int n;char s[34];
 static UInt8 batpcentprev=255;static UInt16 bprev=16381;
 b=SysBatteryInfo(false,0,0,0,0,0,&batpcent);
 if(batpcent==batpcentprev&&bprev==b&&(vexilla&1))return;
 batpcentprev=batpcent;bprev=b;vexilla|=1;
 n=StrLen(StrIToA(s,b/100));s[n++]='.';b%=100;s[n++]=b/10+'0';s[n++]=b%10+'0';
 s[n++]='V';s[n++]=' ';s[n++]='(';n+=StrLen(StrIToA(s+n,batpcent));s[n++]='%';
 s[n++]=')';s[n]=0;FrmCopyLabel(f,fieldID_Battery,s);
}
static void WriteMemory(void)
{UInt32 mem;static UInt32 memprev=0;char s[34];
 if(0==MemCardInfo(0,0,0,0,0,0,0,&mem))if(mem!=memprev||!(vexilla&2))
 {StrIToA(s,mem);FrmCopyLabel(f,fieldID_FreeMem,s);memprev=mem;vexilla|=2;}
}
static void WriteSysInfo(void)
{char s[34];UInt32 t,tps;
 DateTimeType dt;static UInt32 tprev=0;t=TimGetSeconds();
 if(t!=tprev)
 {tprev=t;TimSecondsToDateTime(t,&dt);
  *s=dt.hour/10+'0';s[1]=dt.hour%10+'0';s[2]=':';
  s[3]=dt.minute/10+'0';s[4]=dt.minute%10+'0';s[5]=':';
  s[6]=dt.second/10+'0';s[7]=dt.second%10+'0';s[8]=0;
  FrmCopyLabel(f,fieldID_Time,s);
 }
 {tps=TimGetTicks();StrIToA(s,tps);FrmCopyLabel(f,fieldID_Ticks,s);
  #ifdef DIAG
  tps=TicksToNextSec();StrIToA(s,tps);tps=StrLen(s);s[tps]=s[tps+1]=' ';WinDrawChars(s,tps+2,68,3);
  #endif
 }WriteBattery();WriteMemory();
}
static void GetSysInfo(void)
{char s[34];UInt32 tps;DeviceInfoType portinfo;
 tps=SysTicksPerSecond();StrLen(StrIToA(s,tps));
 FrmCopyLabel(f,fieldID_SysTickspsec,s);WriteBattery();WriteMemory();
 if(SrmGetDeviceInfo(0,&portinfo))return;
 StrIToA(s,(UInt32)(portinfo.serDevMaxBaudRate));
 FrmCopyLabel(f,fieldID_MaxRate,s);
 StrIToA(s,(UInt32)(portinfo.serDevHandshakeBaud));
 FrmCopyLabel(f,fieldID_HSbaud,s);
 FrmCopyLabel(f,fieldID_InfoString,portinfo.serDevPortInfoStr);
}
static void OnEnter(EventType*e)
{f=FrmGetFormPtr(kid=e->data.frmOpen.formID);FrmSetActiveForm(f);FrmDrawForm(f);
 vexilla=0;GetSysInfo();
}
Boolean SysFormHandler(EventType*e)
{switch(e->eType)
 {case frmOpenEvent:OnEnter(e);break;
  case ctlSelectEvent:
   if(e->data.ctlSelect.controlID==kidHelp)AddHelpEvt(kidHelpSysInfo,kid);
   break;
 }WriteSysInfo();return 0;
}
