/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"taip.h"
#include"events.h"
#include"hex.h"
#include"prefs.h"
#include"serial.h"
#include"setnavdata.h"
#include<PalmOS.h>
#define hic(a) a __attribute__ ((section("prot")));a
hic(static int checksum(char*s,int n))
{unsigned char c=0;
 while(n-->0&&*s!='*'&&*s!='<')c^=*s++;if(*s++!='*')return 0;c^='*';
 return c^(hex(s));
}
hic(static int LatDeg(char*s))
{int d=(s[1]-'0')*10+s[2]-'0';if(*s=='-')d=-d;return d;}
hic(static int LonDeg(char*s))
{int d=(s[1]-'0')*100+(s[2]-'0')*10+s[3]-'0';if(*s=='-')d=-d;return d;}
hic(static void Frac(char*s,int n,struct Angle*a))
{Int32 frac=0,x10=1;int i;for(i=0;i++<n;frac=frac*10+*s++-'0')x10*=10;
 a->min=frac*60/x10;x10/=100;a->sec=frac*36/x10%60;x10/=100;
 a->frac=frac*360/x10%1000;
}static struct Angle a;
hic(static char*setLat(char*s,int n))
{if(!s)return 0;a.deg=LatDeg(s);Frac(s+3,n,&a);SetLat(&a);return s+3+n;}
hic(static char*setLon(char*s,int n))
{if(!s)return 0;a.deg=LonDeg(s);Frac(s+4,n,&a);SetLon(&a);return s+4+n;}
hic(static void setqual(char c))
{switch(c)
 {case'0':SetQuality("1");SetSatsInView("3");break;
  case'1':SetQuality("1");SetSatsInView("4");break;
  case'2':SetQuality("2");SetSatsInView("3");break;
  case'3':SetQuality("2");SetSatsInView("4");break;
  default:SetQuality("0");
 }
}
static UInt32 utc;
hic(static char*SetIntUTC(char*s))
{Int32 t=0,i;for(i=0;i++<5;t=t*10+*s++-'0');
 utc=t*FixedScale;SetUTC(utc);return s;
}
hic(static char*SetFracUTC(char*s))
{int tf=0,i;for(i=0;i++<3;tf=tf*10+*s++-'0');utc+=tf;SetUTC(utc);return s;}
hic(static void SetTMUTC(char*s))
{int h,m,sec,msec;char c;c=s[2];s[2]=0;h=StrAToI(s);s[2]=c;
 c=s[4];s[4]=0;m=StrAToI(s+2);s[4]=c;c=s[6];s[6]=0;
 sec=StrAToI(s+4);s[6]=c;c=s[9];s[9]=0;msec=StrAToI(s+6);
 SetUTC((h*3600l+m*60+sec)*FixedScale+msec*FixedScale/1000);s[9]=c;
}
#define STRINT(a,b) 256*(int)(a)+(int)(b)
hic(static int parse(char*s,int is,UInt32 tic))
{Int32 h;char c,*sp,Mess[4];
 if(checksum(s,is))
 {SndPlaySystemSound(sndWarning);if(CheckEnabled())return 0;}s+=2;is-=2;
 SetSensor("GP");MemMove(Mess,s,2);s+=2;
 switch(STRINT(*Mess,Mess[1]))
 {case STRINT('C','P'):s=SetIntUTC(s);
   s=setLat(s,4);s=setLon(s,4);setqual(*s++);break;
  case STRINT('L','N'):s=SetIntUTC(s);s=SetFracUTC(s);
   setdifft(tic);s=setLat(s,7);s=setLon(s,7);c=s[7];s[7]=0;
   h=StrAToI(s);s[7]=c;s+=9;SetAlt(h*3048/10);c=s[4];s[4]=0;
   h=StrAToI(s);s[4]=c;s+=4;SetSpeed(h*1602/10);s+=5;c=s[4];s[4]=0;
   h=StrAToI(s);s[4]=c;s+=4;SetCourse(h*100);sp=s;h=*s++-'0';
   h=h*10+*s++-'0';s+=h*4;s+=10;setqual(*s++);SetSatsInView(sp);break;
  case STRINT('P','V'):s=SetIntUTC(s);setdifft(tic);
   s=setLat(s,5);s=setLon(s,5);c=s[3];s[3]=0;
   h=StrAToI(s);s[3]=c;s+=3;SetSpeed(h*1602);c=s[3];s[3]=0;
   h=StrAToI(s);s[3]=c;s+=3;SetCourse(h*FixedScale);
   setqual(*s++);break;
  case STRINT('T','M'):SetTMUTC(s);
   setdifft(tic);setqual(s[19]);SetSatsInView(s+20);break;
 }return!0;
}        
#define buflen 128
void taipreceive(void)
{static UInt32 t0=0;static char s[buflen];static int i=0;
 const char begin='>',end='<';
 while(Receive(s+i))
 {if((s[i]>'z'&&s[i]<' ')&&!(s[i]=='\n'||s[i]=='\r'))*s=0;
  if(begin==s[i]){t0=TimGetSeconds();s[i=0]=begin;}
  if(*s==begin&&s[i]==end)
  {if(parse(s,i,t0)){SetScrollData(s,i+1);AddUserEvt(navEvt);}*s=~begin;}
  ++i;if(i>=buflen)s[i=0]=~begin;
 }
}
