/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"tsip.h"
#include"events.h"
#include"prefs.h"
#include"serial.h"
#include"setnavdata.h"
#include"navdata.h"
#define dle (unsigned char)0x10
#define etx (unsigned char)0x03
#include<PalmOS.h>
#define hic(a) a __attribute__ ((section("prot")));a
const double pi=3.14159265358979323846;
hic(static float GetFloat(char*s))
{float f;char*p=(char*)&f;int i;for(i=0;i<3;*p++=*s++)i++;return f;}
hic(static double GetDouble(char*s))
{double f;char*p=(char*)&f;int i;for(i=0;i<7;*p++=*s++)i++;return f;}
static float GPSminusUTC=0;
hic(static int length(unsigned char s))
{switch(s)
 {case 0x41:return 11;case 0x42:return 17;
  case 0x46:return 3;case 0x43:case 0x4A:case 0x56:case 0x6D:return 21;
  case 0x83:case 0x84:return 37;
 }return 0;
}
hic(static void printDouble(char*s,double x))
{Int32 n;if(x<0){*s++='-';x=-x;}n=x;StrIToA(s,n);x-=n;x*=1000;n=x;
 s+=StrLen(s);*s++='.';*s++='0'+n/100;*s++='0'+(n/10)%10;*s++='0'+n%10;*s=0;
}
hic(static void FToAngle(struct Angle*l,double x))
{int sign=0;if(x<0){sign=!0;x=-x;}x*=360./pi;l->deg=(int)x;
 x-=l->deg;if(x<0)x=-x;x*=60;l->min=(int)x;x-=l->min;x*=60;l->sec=(int)x;
 x-=l->sec;l->frac=(int)(x*1000);if(sign)l->deg=-l->deg;
}
hic(static void parse41(char*s,UInt32 tic,char*sc))
{UInt32 t;float x=GetFloat(s+1),d=GetFloat(s+7);const Int32 SecsPDay=24*3600l;
 GPSminusUTC=d;StrCat(sc,": t=");printDouble(sc+StrLen(sc),x);
 StrCat(sc,"s;  w=");t=(s[5]<<8)+s[6];StrIToA(sc+StrLen(sc),t);
 StrCat(sc,"; GPS-UTC=");StrIToA(sc+StrLen(sc),(Int32)d);StrCat(sc,"s");x-=d;
 x-=((Int32)x/SecsPDay)*SecsPDay;SetUTC(x*FixedScale);setdifft(tic);
}
hic(static void parse42(char*s,UInt32 tic,char*sc))
{float x=GetFloat(s+1),y=GetFloat(s+5),z=GetFloat(s+9),b=GetFloat(s+13),
 t=GetFloat(s+17);StrCat(sc,":x=");printDouble(sc+StrLen(sc),x);
 StrCat(sc+StrLen(sc),"m;y=");printDouble(sc+StrLen(sc),y);
 StrCat(sc,"m;z=");printDouble(sc+StrLen(sc),z);StrCat(sc,"m;b=");
 printDouble(sc+StrLen(sc),b);StrCat(sc,"m;t=");
 printDouble(sc+StrLen(sc),t);StrCat(sc,"s");
}
hic(static void parse43(char*s,UInt32 tic,char*sc))
{float x=GetFloat(s+1),y=GetFloat(s+5),z=GetFloat(s+9),b=GetFloat(s+13),
 t=GetFloat(s+17);StrCat(sc,":Vx=");printDouble(sc+StrLen(sc),x);
 StrCat(sc+StrLen(sc),"m/s;Vy=");printDouble(sc+StrLen(sc),y);
 StrCat(sc,"m/s;Vz=");printDouble(sc+StrLen(sc),z);StrCat(sc,"m/s;br=");
 printDouble(sc+StrLen(sc),b);StrCat(sc,"m/s;t=");
 printDouble(sc+StrLen(sc),t);StrCat(sc,"s");
}
hic(static void parse46(char*s,char*sc))
{char q[2]="1";if(s[1])*q='0';SetQuality(q);StrCat(sc,":");
 switch(s[1])
 {case 0:StrCat(sc,"doing fixes");break;
  case 1:StrCat(sc,"haven't got time");break;
  case 2:StrCat(sc,"need initialization");break;
  case 3:StrCat(sc,"too high PDOP");break;
  case 8:StrCat(sc,"no usable sats");break;
  case 9:StrCat(sc,"1 usable sat");break;
  case 10:StrCat(sc,"2 usable sats");break;
  case 11:StrCat(sc,"3 usable sats");break;
  case 13:StrCat(sc,"unusable sat");break;
 }
 if(s[2]&1)StrCat(sc,";BBRAM fail");
 if(s[2]&0x10)StrCat(sc,";Antenna fail");
}static struct Angle a;
hic(static void parse4A(char*s,UInt32 tic,char*sc))
{float lat=GetFloat(s+1),lon=GetFloat(s+5),alt=GetFloat(s+9),cb=GetFloat(s+13),
 t=GetFloat(s+17);FToAngle(&a,lat);SetLat(&a);FToAngle(&a,lon);SetLon(&a);
 SetAlt(alt*FixedScale);StrCat(sc,":Lat=");GetLat(sc+StrLen(sc));
 StrCat(sc+StrLen(sc),"; Lon=");GetLon(sc+StrLen(sc));StrCat(sc,";Alt=");
 printDouble(sc+StrLen(sc),alt);StrCat(sc,"m;cb=");
 printDouble(sc+StrLen(sc),cb);StrCat(sc,"m;t=");printDouble(sc+StrLen(sc),t);
}
hic(static void parse56(char*s,UInt32 tic,char*sc))
{float x=GetFloat(s+1),y=GetFloat(s+5),z=GetFloat(s+9),b=GetFloat(s+13),
 t=GetFloat(s+17);StrCat(sc,":Ve=");printDouble(sc+StrLen(sc),x);
 StrCat(sc+StrLen(sc),"m/s;Vn=");printDouble(sc+StrLen(sc),y);
 StrCat(sc,"m/s;Vu=");printDouble(sc+StrLen(sc),z);StrCat(sc,"m/s;br=");
 printDouble(sc+StrLen(sc),b);StrCat(sc,"m/s;t=");
 printDouble(sc+StrLen(sc),t);StrCat(sc,"s");
}
hic(static void parse6D(char*s,char*sc))
{int n,i;char N[2]="1";float pdop=GetFloat(s+2),hdop=GetFloat(s+6),
  vdop=GetFloat(s+10),tdop=GetFloat(s+14);StrCat(sc,":");
 SetQuality(N);n=(unsigned char)s[1]&0xF0>>4;
 *N='0'+n/10;N[1]=n%10+'0';SetSatsInView(N);SetHDOP(hdop*FixedScale);
 if(s[1]&7==4)StrCat(sc,"3D");else StrCat(sc,"2D");
 if(s[1]&8)StrCat(sc,"A");else StrCat(sc,"M");
 StrCat(sc,";PDOP=");printDouble(sc+StrLen(sc),pdop);
 StrCat(sc,";HDOP=");printDouble(sc+StrLen(sc),hdop);
 StrCat(sc,";VDOP=");printDouble(sc+StrLen(sc),vdop);
 StrCat(sc,";TDOP=");printDouble(sc+StrLen(sc),tdop);
 StrCat(sc,";sats:(");StrIToA(sc+StrLen(sc),n);StrCat(sc,")");
 for(i=0;i<n;i++)StrIToA(sc+StrLen(sc),s[18+i]);
}
hic(static void parse83(char*s,UInt32 tic,char*sc))
{double x=GetDouble(s+1),y=GetDouble(s+9),z=GetDouble(s+17),cb=GetDouble(s+25);
 float t=GetFloat(s+33);StrCat(sc,":X=");printDouble(sc+StrLen(sc),x);
 StrCat(sc+StrLen(sc),"m;Y=");printDouble(sc+StrLen(sc),y);StrCat(sc,"m;Z=");
 printDouble(sc+StrLen(sc),z);StrCat(sc,"m;cb=");printDouble(sc+StrLen(sc),cb);
 StrCat(sc,"m;t=");printDouble(sc+StrLen(sc),t);
}
hic(static void parse84(char*s,UInt32 tic,char*sc))
{double lat=GetDouble(s+1),lon=GetDouble(s+9),alt=GetDouble(s+17),
  cb=GetDouble(s+25);float t=GetFloat(s+33);
 FToAngle(&a,lat);SetLat(&a);FToAngle(&a,lon);SetLon(&a);SetAlt(alt*FixedScale);
 StrCat(sc,":Lat=");GetLat(sc+StrLen(sc));
 StrCat(sc+StrLen(sc),";Lon=");GetLon(sc+StrLen(sc));StrCat(sc,";Alt=");
 printDouble(sc+StrLen(sc),alt);StrCat(sc,"m;cb=");
 printDouble(sc+StrLen(sc),cb);StrCat(sc,"m;t=");printDouble(sc+StrLen(sc),t);
}
hic(static int parse(unsigned char*s,int is,UInt32 tic))
{static char sc[170],sc1[17];
 if(is!=length(*s))
 {SndPlaySystemSound(sndWarning);if(CheckEnabled())return 0;}
 SetSensor("GP");StrCopy(sc,"#");StrIToH(sc1,*s);StrCat(sc,sc1+StrLen(sc1)-2);
 StrCat(sc,"(");StrIToA(sc+StrLen(sc),is);StrCat(sc,")");
 switch(*s)
 {case 0x41:parse41(s,tic,sc);break;case 0x4A:parse4A(s,tic,sc);break;
  case 0x42:parse42(s,tic,sc);break;case 0x43:parse43(s,tic,sc);break;
  case 0x46:parse46(s,sc);break;
  case 0x56:parse56(s,tic,sc);break;case 0x6D:parse6D(s,sc);break;
  case 0x83:parse83(s,tic,sc);break;case 0x84:parse84(s,tic,sc);break;
 }SetScrollData(sc,StrLen(sc));return!0;
}        
#define buflen 260
#define maxlen 256
void tsipreceive(void)
{static unsigned char s[buflen],pqpr=0,pr=0,cur;
 static int par=0,capitur=0,i;static UInt32 t0=0;
 while(Receive(&cur))
 {if(capitur)
  {if(++i<0){pqpr=pr;pr=cur;continue;}s[i]=pqpr;
   if(pqpr==dle){if(par)i--;else if(pr!=dle&&pr!=etx)capitur=0;par=!par;}
   if(pqpr==dle&&pr==etx&&par){parse(s,i,t0);AddUserEvt(navEvt);capitur=0;}
   if((pqpr==etx&&pr==dle&&cur!=dle)||i>=maxlen)capitur=0;
  }
  if(!capitur)
  {if(pqpr==etx&&pr==dle&&cur!=dle){t0=TimGetSeconds();i=-2;capitur=!0;par=0;}}
  pqpr=pr;pr=cur;
 }
}
